package com.wwsean08.clear;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.logging.Logger;

import me.kalmanolah.extras.OKUpdater;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.util.config.Configuration;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;

public class Clear extends JavaPlugin {
	Logger log = Logger.getLogger("Minecraft");
	public final String VERSION = "1.7.0";
	private final double customDBVersion = 1.13;
	private final String PREFIX = "[ClearInv]";
	private static final String mainDirectory = "plugins" + File.separator + "ClearInv";
	private static File custom = new File(mainDirectory + File.separator + "customItems.dat");
	private File configFile = new File(mainDirectory + File.separator + "config.yml");
	private static Properties prop = new Properties();
	private static Server server;
	public static PermissionHandler ph;
	private Configuration config;
	private HashMap<Player, ItemStack[]> originalInventory;
	private PluginManager pm;
	private ClearPlayerListener pl;

	public void onEnable() {
		pl = new ClearPlayerListener(this);
		originalInventory = new HashMap<Player, ItemStack[]>();
		server = Bukkit.getServer();
		pm = server.getPluginManager();
		config = this.getConfiguration();
		if(config.getBoolean("autoupdate", true)){
			String name = this.getDescription().getName();
			String version = this.getDescription().getVersion();
			String checklocation = "http://dcp.wwsean08.com/check.php";
			String downloadlocation = "http://dcp.wwsean08.com/dl.php";
			String logprefix = PREFIX;
			OKUpdater.update(name, version, checklocation, downloadlocation, log, logprefix);
		}
		new File(mainDirectory).mkdir();
		if (!custom.exists()) {
			log.info(PREFIX + " Now updating customItems.dat");
			replaceFile();
		}else {
			try {
				FileInputStream in = new FileInputStream(custom);
				prop.load(in);
				double version = Double
				.parseDouble(prop.getProperty("version"));
				in.close();
				if (customDBVersion >= version) {
					log.info(PREFIX + " Now updating customItems.dat");
					custom.delete();
					replaceFile();
					log.info(PREFIX + " Finished updating customItems.dat");
				}
			} catch (IOException ex) {

			}
		}
		if(!configFile.exists()){
			createConfig();
		} 
		getPerm();
		pm.registerEvent(Event.Type.PLAYER_QUIT, pl, Event.Priority.Monitor, this);
		pm.registerEvent(Event.Type.PLAYER_KICK, pl, Event.Priority.Monitor, this);
		log.info(PREFIX + " clear inventory version " + VERSION + " enabled");
	}

	public void onDisable() {
		log.info(PREFIX + " clear inventory version " + VERSION + " disabled");
	}

	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args) {
		if (commandLabel.equalsIgnoreCase("clear")) {
			if (sender instanceof Player) {
				if (ph != null) 
					playerPerm(sender, args);

				// if no permissions set up
				else 
					playerNoPerm(sender, args);

			} else if (sender instanceof ConsoleCommandSender) 
				consoleClear(sender, args);
		}
		if(commandLabel.equalsIgnoreCase("preview")){
			if(sender instanceof Player){
				if(args.length == 1){
					Player player = (Player) sender;
					Player affected = server.matchPlayer(args[0]).get(0);
					if(affected!=null){
						if(ph.has(player, "clear.other") || player.isOp())
							preview(player, affected);
						else{
							sender.sendMessage("You do not have permission to use this command");
							log.warning(PREFIX + player.getDisplayName() + " Attempted to preview another players inventory");
						}
					}
				}
			}
		}
		if(commandLabel.equalsIgnoreCase("unpreview")){
			if(sender instanceof Player){
				Player player = (Player) sender;
				unpreview(player);
			}
		}
		return true;
	}

	/*
	 * takes care of commands if permissions system is detected
	 * @param sender is the player who sent the command
	 * @param args are the arguments for the command
	 * 
	 */
	private void playerPerm(CommandSender sender, String[] args){
		Player player = (Player) sender;
		if (ph.has(player, "clear.self") || ph.has(player, "clear.other")) {
			if (args.length == 0)
				clearAll(player);
			else if (args[0].equalsIgnoreCase("except")) 
				clearExcept(player, args);
			else if (args[0].equalsIgnoreCase("armor"))
				clearArmor(player);
			else if(args[0].equalsIgnoreCase("boots") || args[0].equalsIgnoreCase("boot")){
				player.getInventory().setBoots(null);
				player.sendMessage("Boots removed");
			}else if(args[0].equalsIgnoreCase("helmet") || args[0].equalsIgnoreCase("helm")){
				player.getInventory().setHelmet(null);
				player.sendMessage("Helmet removed");
			}else if(args[0].equalsIgnoreCase("pants") || args[0].equalsIgnoreCase("leggings")){
				player.getInventory().setLeggings(null);
				player.sendMessage("Leggings removed");
			}else if(args[0].equalsIgnoreCase("shirt") || args[0].equalsIgnoreCase("chestplate") || args[0].equalsIgnoreCase("chest")){
				player.getInventory().setChestplate(null);
				player.sendMessage("Chestplate removed");
			}else if (args[0].equalsIgnoreCase("help")) {
				playerHelp(sender);
			} else if ((server.getPlayer(args[0]) != null) && (ph.has(player, "clear.other") || sender.isOp())) {
				Player affectedPlayer = server.matchPlayer(args[0]).get(0);
				if (args.length == 1) {
					clearAllRemote(player, affectedPlayer);
				} else if (args[1].equalsIgnoreCase("except")) {
					clearExceptRemote(player, affectedPlayer, args);
				} else if(args[1].equalsIgnoreCase("armor")){
					clearArmorRemote(player, affectedPlayer);
				} else
					clearItemRemote(player, affectedPlayer, args);
			} else if ((server.getPlayer(args[0]) != null) && !((ph.has(player, "clear.other") || !sender.isOp()))) {
				sender.sendMessage("You do not have permission to use that command");
				log.warning(PREFIX + player.getDisplayName() + " tried to clear another players inventory without the necessary permissions");
			} else if (args.length >= 1 && (ph.has(player, "clear.self") || ph.has(player, "clear.other"))) {
				clearItem(player, args);
			}
		}
	}

	/*
	 * takes care of commands if no permissions system is detected
	 * @param sender is the player who sent the command
	 * @param args are the arguments for the command
	 * 
	 */
	private void playerNoPerm(CommandSender sender, String[] args){
		Player player = (Player) sender;
		if (args.length == 0) 
			clearAll(player);
		else if (args[0].equalsIgnoreCase("except")) 
			clearExcept(player, args);
		else if (args[0].equalsIgnoreCase("help")) 
			playerHelp(sender);
		//begin armor removal
		else if(args[0].equalsIgnoreCase("armpr"))
			clearArmor(player);
		else if(args[0].equalsIgnoreCase("boots") || args[0].equalsIgnoreCase("boot")){
			player.getInventory().setBoots(null);
			player.sendMessage("Boots removed");
		}else if(args[0].equalsIgnoreCase("helmet") || args[0].equalsIgnoreCase("helm")){
			player.getInventory().setHelmet(null);
			player.sendMessage("Helmet removed");
		}else if(args[0].equalsIgnoreCase("pants") || args[0].equalsIgnoreCase("leggings")){
			player.getInventory().setLeggings(null);
			player.sendMessage("Leggings removed");
		}else if(args[0].equalsIgnoreCase("shirt") || args[0].equalsIgnoreCase("chestplate") || args[0].equalsIgnoreCase("chest")){
			player.getInventory().setChestplate(null);
			player.sendMessage("Chestplate removed");
		}
		//end armor removal
		else if (server.getPlayer(args[0]) != null) {
			if (sender.isOp()) {
				Player affectedPlayer = server.matchPlayer(args[0]).get(0);
				if (args.length == 1)
					clearAllRemote(player, affectedPlayer);
				else if (args[1].equalsIgnoreCase("except")) 
					clearExceptRemote(player, affectedPlayer, args);
				else 
					clearItemRemote(player, affectedPlayer, args);
			} else {
				sender.sendMessage("You do not have permission to use that command");
				log.warning(PREFIX + player.getDisplayName() + " tried to clear another players inventory without the necessary permissions");
			}
		} else 
			clearItem(player, args);
	}

	/*
	 * takse care of commands sent by the console
	 * @param sender is the console which sent the command
	 * @param args are the arguments for the command
	 */
	private void consoleClear(CommandSender sender, String[] args){
		if (args.length >= 1) {
			Player player = server.getPlayer(args[0]);
			if (args.length == 1)
				clearAllRemote(sender, player);
			else if (args[1].equalsIgnoreCase("except"))
				clearExceptRemote(sender, player, args);
			else if(args[1].equalsIgnoreCase("armor"))
				clearArmorRemote(sender, player);
			else if(args[1].equalsIgnoreCase("boots") || args[1].equalsIgnoreCase("boot")){
				player.getInventory().setBoots(null);
				sender.sendMessage("Boots removed from " + player.getDisplayName());
			}else if(args[1].equalsIgnoreCase("helmet") || args[1].equalsIgnoreCase("helm")){
				player.getInventory().setHelmet(null);
				sender.sendMessage("Helmet removed from " + player.getDisplayName());
			}else if(args[1].equalsIgnoreCase("pants") || args[1].equalsIgnoreCase("leggings")){
				player.getInventory().setLeggings(null);
				sender.sendMessage("Leggings removed from " + player.getDisplayName());
			}else if(args[1].equalsIgnoreCase("shirt") || args[1].equalsIgnoreCase("chestplate") || args[1].equalsIgnoreCase("chest")){
				player.getInventory().setChestplate(null);
				sender.sendMessage("Chestplate removed from " + player.getDisplayName());
			}
			else if (args[0].equalsIgnoreCase("help"))
				consoleHelp(sender);
			else 
				clearItemRemote(sender, player, args);
		}
	}
	/*
	 * displays the help text if the console sent the command
	 */
	private void consoleHelp(CommandSender sender){
		sender.sendMessage(ChatColor.BLUE + "Because you are the server console, you don't have an inventory, however you can clear other players inventories");
		sender.sendMessage(ChatColor.BLUE + "To clear a players inventory completely type:");
		sender.sendMessage(ChatColor.RED + "/clear <player>");
		sender.sendMessage(ChatColor.BLUE + "To clear certain items from a players inventory type:");
		sender.sendMessage(ChatColor.RED + "/clear <player> <item1> [item2] [item3]...");
		sender.sendMessage(ChatColor.BLUE + "And if you want to clear everything bu8t certain items from a players inventory type this:");
		sender.sendMessage(ChatColor.RED + "/clear <player> except <item1> [item2] [item3]...");
		sender.sendMessage(ChatColor.GOLD + "Thank you for using wwsean08's inventory clearing plugin");
	}
	/*
	 * displays the help text if the player sent the command
	 */
	private void playerHelp(CommandSender sender){
		sender.sendMessage(ChatColor.AQUA + "you can clear your inventory of everything like this:");
		sender.sendMessage(ChatColor.RED + "/clear");
		sender.sendMessage(ChatColor.AQUA + "You can exclude items using the except keyword as the first argument like this:");
		sender.sendMessage(ChatColor.RED + "/clear except sand");
		sender.sendMessage(ChatColor.AQUA + "You can delete select items by naming them as arguments like this:");
		sender.sendMessage(ChatColor.RED + "/clear sand gravel");
		if (sender.isOp() || ph.has((Player) sender, "clear.other")) {
			sender.sendMessage(ChatColor.AQUA + "And you have permission to clear other peoples invetories, and view them");
			sender.sendMessage(ChatColor.RED + "/clear name item1 item2...");
			sender.sendMessage(ChatColor.AQUA + "Tp view them the command is preview and to unview them its unpreview");
			sender.sendMessage(ChatColor.RED + "/preview <user> to put the players inventory in yours");
			sender.sendMessage(ChatColor.RED + "/unpreview to restore your inventory");
		}
	}

	private void preview(Player previewer, Player previewee){
		ItemStack[] preview = previewee.getInventory().getContents();
		if(!originalInventory.containsKey(previewer))
			originalInventory.put(previewer, previewer.getInventory().getContents());
		previewer.getInventory().setContents(preview);
	}

	public void unpreview(Player previewer){
		if(originalInventory.containsKey(previewer)){
			previewer.getInventory().clear();
			previewer.getInventory().setContents(originalInventory.get(previewer));
			originalInventory.remove(previewer);
		}
	}
	
	/*
	 * Clears all the items out of the players inventory
	 * @param sender is the player who sent the command
	 */
	public void clearAll(Player sender) {
		sender.getInventory().clear();
		sender.sendMessage("Inventory Cleared");
	}

	/*
	 * Clears all the items out of another user's inventory
	 * @param sender is the player who sent the command.
	 * @param affected is the player who's inventory gets cleared.
	 */
	public void clearAllRemote(CommandSender sender, Player affected) {
		affected.getInventory().clear();
		sender.sendMessage(affected.getDisplayName() + "'s inventory has been cleared.");
	}

	/*
	 * clears all the items except for the ones specified by the player.
	 * @param sender is the player who sent the command
	 * @param args the list of items to exclude (either in number of name form).
	 */
	public void clearExcept(Player sender, String[] args) {
		ArrayList<Material> exception = new ArrayList<Material>();
		for (int i = 1; i < args.length; i++) {
			Material newMaterial = Material.matchMaterial(args[i]);
			if (newMaterial == null) {
				int id = tryID(args[i]);
				if (id == -2) {
					sender.sendMessage(ChatColor.RED + "sorry did you make a typo, the block " + args[i].toLowerCase() + " does not exist");
					continue;
				}
				if (id == -1) {
					String material = tryString(args[i]);
					newMaterial = Material.matchMaterial(material);
				} else {
					newMaterial = Material.getMaterial(id);
				}
			}
			sender.sendMessage("adding " + args[i].toLowerCase() + " to exception list");
			exception.add(newMaterial);
		}
		PlayerInventory inventory = sender.getInventory();
		for (int i = 0; i < 36; i++) {
			boolean match = false;
			if (inventory.getItem(i).getType() != null)
				for (int j = 0; j < exception.size(); j++) {
					String itemName = inventory.getItem(i).getType().name();
					String exceptionName = exception.get(j).name();
					if (itemName == exceptionName) {
						match = true;
					}
				}
			if (!match) {
				inventory.clear(i);
			}
		}
	}

	/*
	 * clears all the items except for the ones specified by the player.
	 * 
	 * @param sender is the player who sent the command
	 * 
	 * @param args the list of items to exclude (either in number of name form).
	 */
	public void clearExceptRemote(CommandSender sender, Player affected, String[] args) {
		ArrayList<Material> exception = new ArrayList<Material>();
		for (int i = 2; i < args.length; i++) {
			Material newMaterial = Material.matchMaterial(args[i]);
			if (newMaterial == null) {
				int id = tryID(args[i]);
				if (id == -2) {
					if (!args[i].equalsIgnoreCase("except"))
						sender.sendMessage(ChatColor.RED + "sorry did you make a typo, the block " + args[i].toLowerCase() + " does not exist");
					continue;
				}
				if (id == -1) {
					String material = tryString(args[i]);
					newMaterial = Material.matchMaterial(material);
				} else {
					newMaterial = Material.getMaterial(id);
				}
			}
			sender.sendMessage("adding " + args[i].toLowerCase() + " to exception list");
			exception.add(newMaterial);
		}
		PlayerInventory inventory = affected.getInventory();
		for (int i = 0; i < 36; i++) {
			boolean match = false;
			if (inventory.getItem(i).getType() != null)
				for (int j = 0; j < exception.size(); j++) {
					String itemName = inventory.getItem(i).getType().name();
					String exceptionName = exception.get(j).name();
					if (itemName == exceptionName) {
						match = true;
					}
				}
			if (!match) {
				inventory.clear(i);
			}
		}
	}

	/*
	 * clears all of the selected items by the player
	 * 
	 * @param Sender the player who sent the command
	 * 
	 * @param args is the list or item(s) that the user wants to delete from
	 * their inventory
	 */
	public void clearItem(Player sender, String[] args) {
		PlayerInventory inventory = sender.getInventory();
		for (int i = 0; i < args.length; i++) {
			Material item = null;
			item = Material.matchMaterial(args[i]);
			if (item == null) {
				int id = tryID(args[i]);
				if (id == -2) {
					sender.sendMessage(ChatColor.RED + "sorry did you make a typo, the block " + args[i].toLowerCase() + " does not exist");
					continue;
				}
				if (id == -1) {
					String material = tryString(args[i]);
					item = Material.matchMaterial(material);
				} else
					item = Material.getMaterial(id);
			}
			if (inventory.contains(item)) {
				sender.sendMessage(args[i].toLowerCase() + " has been removed from your inventory");
				if (inventory.contains(item))
					inventory.remove(item);
			} else if (!inventory.contains(item))
				sender.sendMessage("theres no " + args[i].toLowerCase() + " in your inventory");
		}
	}

	/*
	 * clears all of the selected items by the player
	 * 
	 * @param Sender is the player who sent the command.
	 * 
	 * @param affected is the player who's items are being removed
	 * 
	 * @param args is the list or item(s) that the user wants to delete from
	 * their inventory
	 */
	public void clearItemRemote(CommandSender sender, Player affected, String[] args) {
		PlayerInventory inventory = affected.getInventory();
		for (int i = 1; i < args.length; i++) {
			Material item = null;
			item = Material.matchMaterial(args[i]);
			if (item == null) {
				int id = tryID(args[i]);
				if (id == -2) {
					sender.sendMessage(ChatColor.RED + "sorry did you make a typo, the block " + args[i].toLowerCase() + " does not exist");
					continue;
				}
				if (id == -1) {
					String material = tryString(args[i]);
					item = Material.matchMaterial(material);
				} else 
					item = Material.getMaterial(id);
			}
			if (inventory.contains(item)) {
				sender.sendMessage(args[i] + " has been removed from " + affected.getDisplayName() + "'s inventory");
				if (inventory.contains(item))
					inventory.remove(item);
			} else if (!inventory.contains(item))
				sender.sendMessage("there's no " + args[i].toLowerCase() + " in " + affected.getDisplayName() + "'s inventory");
		}
	}

	private void clearArmor(Player sender){
		sender.getInventory().setBoots(null);
		sender.getInventory().setChestplate(null);
		sender.getInventory().setHelmet(null);
		sender.getInventory().setLeggings(null);
		sender.sendMessage("Armor removed");
	}

	private void clearArmorRemote(CommandSender sender, Player affected){
		affected.getInventory().setBoots(null);
		affected.getInventory().setChestplate(null);
		affected.getInventory().setHelmet(null);
		affected.getInventory().setLeggings(null);
		sender.sendMessage(affected.getName() + " has had his armor removed by you");
	}

	private int tryID(String input) {
		int id = 0;
		try {
			FileInputStream in = new FileInputStream(custom);
			prop.load(in);
			String property = prop.getProperty(input.toLowerCase().trim());
			if (property == null) 
				return -2; // the property doesn't exist so it's not gonna be found.
			id = Integer.parseInt(property);
			in.close();
		} catch (NumberFormatException ex) {
			return -1; // it's a string and not an integer
		} catch (IOException ex) {
			log.warning(PREFIX + " Error accessing customItems.dat");
		}
		return id;
	}

	private String tryString(String input) {
		String result = "";
		try {
			FileInputStream in = new FileInputStream(custom);
			prop.load(in);
			result = prop.getProperty(input.toLowerCase().trim());
			in.close();
		} catch (IOException ex) {

		}
		return result;
	}

	private void getPerm() {
		Plugin perm = server.getPluginManager().getPlugin("Permissions");
		if (ph == null) {
			if (perm != null) {
				ph = ((Permissions) perm).getHandler();
				log.info(PREFIX + " Permission system detected");
			} else {
				log.warning(PREFIX + " No permissions system detected, elevated commands dafaulting to OP");
			}
		}
	}

	/*
	 * writes the custom.dat, remember to update the version number upon editing
	 */
	private void replaceFile() {
		try {
			custom.createNewFile();
			FileOutputStream out = new FileOutputStream(custom);
			prop.put("version", Double.toString(customDBVersion));
			prop.put("diamondsword", "276");
			prop.put("diamondpick", "278");
			prop.put("diamondpickaxe", "278");
			prop.put("diamondaxe", "279");
			prop.put("diamondhoe", "293");
			prop.put("diamondspade", "277");
			prop.put("diamondshovel", "277");
			prop.put("woodsword", "268");
			prop.put("woodpick", "270");
			prop.put("woodpickaxe", "270");
			prop.put("woodaxe", "271");
			prop.put("woodhoe", "290");
			prop.put("woodspade", "269");
			prop.put("woodshovel", "269");
			prop.put("stonesword", "272");
			prop.put("stonepick", "274");
			prop.put("stonepickaxe", "274");
			prop.put("stoneaxe", "275");
			prop.put("stonehoe", "291");
			prop.put("stonespade", "273");
			prop.put("stoneshovel", "273");
			prop.put("ironsword", "267");
			prop.put("ironpick", "257");
			prop.put("ironpickaxe", "257");
			prop.put("ironaxe", "258");
			prop.put("ironhoe", "292");
			prop.put("ironspade", "256");
			prop.put("ironshovel", "256");
			prop.put("goldsword", "283");
			prop.put("goldpick", "285");
			prop.put("goldpickaxe", "285");
			prop.put("goldaxe", "286");
			prop.put("goldhoe", "294");
			prop.put("goldspade", "284");
			prop.put("goldshovel", "284");
			prop.put("ironingot", "265");
			prop.put("ironore", "15");
			prop.put("ironblock", "42");
			prop.put("goldingot", "266");
			prop.put("goldblock", "41");
			prop.put("goldore", "14");
			prop.put("redstonetorch", "76");
			prop.put("bedblock", "26");
			prop.put("brownmushroom", "39");
			prop.put("burningfurnace", "62");
			prop.put("brickblock", "45");
			prop.put("cakeblock", "92");
			prop.put("chainmailboots", "chainmail_boots");
			prop.put("chainmailchestplate", "chainmail_chestplate");
			prop.put("chainmailhelmet", "chainmail_helmet");
			prop.put("chainmailleggings", "chainmail_leggings");
			prop.put("chainmailpants", "chainmail_pants");
			prop.put("clayball", "337");
			prop.put("clayballs", "337");
			prop.put("claybrick", "336");
			prop.put("clayblock", "82");
			prop.put("coalore", "16");
			prop.put("cobble", "4");
			prop.put("cobblestairs", "67");
			prop.put("cobblestair", "67");
			prop.put("cobblestonestairs", "67");
			prop.put("cobblestonestair", "67");
			prop.put("cookedfish", "350");
			prop.put("craftingtable", "58");
			prop.put("craftingbench", "58");
			prop.put("deadbush", "32");
			prop.put("deadshrub", "32");
			prop.put("detectorrail", "28");
			prop.put("diamondblock", "57");
			prop.put("diamondore", "56");
			prop.put("fishingpole", "346");
			prop.put("fishingrod", "346");
			prop.put("flintandsteel", "259");
			prop.put("glowstonedust", "348");
			prop.put("goldenapple", "322");
			prop.put("greenrecord", "2257");
			prop.put("greenmusicdisk", "2257");
			prop.put("grilledpork", "320");
			prop.put("cookedpork", "320");
			prop.put("grilledporkchops", "320");
			prop.put("cookedporkchops", "320");
			prop.put("inksack", "351");
			prop.put("inksac", "351");
			prop.put("irondoor", "71");
			prop.put("jackolantern", "91");
			prop.put("lapisblock", "22");
			prop.put("lapisore", "21");
			prop.put("lavabucket", "327");
			prop.put("waterbucket", "326");
			prop.put("milkbucket", "335");
			prop.put("mobspawner", "52");
			prop.put("mossycobblestone", "48");
			prop.put("mossstone", "48");
			prop.put("mossycobble", "48");
			prop.put("mushroomsoup", "282");
			prop.put("mushroomstew", "282");
			prop.put("noteblock", "25");
			prop.put("poweredminecart", "343");
			prop.put("poweredrail", "27");
			prop.put("rawfish", "349");
			prop.put("fish", "349");
			prop.put("redmushroom", "40");
			prop.put("redrose", "38");
			prop.put("rose", "38");
			prop.put("redstoneore", "73");
			prop.put("redstonewire", "55");
			prop.put("slimeball", "341");
			prop.put("snowball", "332");
			prop.put("snowblock", "80");
			prop.put("soulsand", "88");
			prop.put("button", "77");
			prop.put("stonebutton", "77");
			prop.put("storagecart", "342");
			prop.put("storageminecart", "342");
			prop.put("sugarcane", "338");
			prop.put("sugarcaneblock", "83");
			prop.put("trapdoor", "96");
			prop.put("hatch", "96");
			prop.put("wooddoor", "64");
			prop.put("woodendoor", "64");
			prop.put("woodenplate", "72");
			prop.put("woodplate", "72");
			prop.put("woodstairs", "53");
			prop.put("woodenstairs", "53");
			prop.put("yellowflower", "37");
			prop.put("dandelion", "37");
			prop.put("leatherboots", "leather_boots");
			prop.put("leathertunic", "leather_chestplate");
			prop.put("leatherchestplate", "leather_chestplate");
			prop.put("leatherchest", "leather_chestplate");
			prop.put("leatherleggings", "leather_leggings");
			prop.put("leatherpants", "leather_leggings");
			prop.put("leatherchaps", "leather_leggings");
			prop.put("leatherhelmet", "leather_helmet");
			prop.put("leathercap", "leather_helmet");
			prop.put("ironboots", "iron_boots");
			prop.put("ironchestplate", "iron_chestplate");
			prop.put("ironchest", "iron_chestplate");
			prop.put("ironleggings", "iron_leggings");
			prop.put("ironpants", "iron_leggings");
			prop.put("ironhelmet", "iron_helmet");
			prop.put("goldboots", "gold_boots");
			prop.put("goldchestplate", "gold_chestplate");
			prop.put("goldchest", "gold_chestplate");
			prop.put("goldleggings", "gold_leggings");
			prop.put("goldpants", "gold_leggings");
			prop.put("goldhelmet", "gold_helmet");
			prop.put("diamondboots", "diamond_boots");
			prop.put("diamondchestplate", "diamond_chestplate");
			prop.put("diamondchest", "diamond_chestplate");
			prop.put("diamondleggings", "diamond_leggings");
			prop.put("diamondpants", "diamond_leggings");
			prop.put("diamondhelmet", "diamond_helmet");
			prop.put("arrows", "262");
			prop.put("stickypiston", "29");
			prop.put("goopiston", "29");
			prop.put("piston", "33");
			prop.put("pistons", "33");
			prop.put("slimepiston", "29");
			prop.put("shear", "359");
			prop.put("ironshears", "359");
			prop.put("scissors", "359");
			prop.put("leaf", "18");
			prop.put("brick", "45");
			prop.put("rail", "66");
			prop.store(out, "Do NOT Edit");
			out.flush();
			out.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	private void createConfig(){
		config.setProperty("autoupdate", true);
		config.save();
	}
}
